package com.tofly.feesapi.wxgl.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.WxXbsq;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.dto.WxCommonDto;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxDbsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxXbsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.service.WxXbsqService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;

@RestController
@RequestMapping("/wxxbsq")
@Api(tags = "微信-校表申请接口")
public class WxXbsqController {

    @Autowired
    private WxXbsqService wxXbsqService;

    @GetMapping("/getpage")
    @ApiOperation(value = "自定义分页查询")
    public ResultRespone<Page<WxXbsqVo>> getWxXbsqPage(Page page, @ModelAttribute WxCommonDto dto) {
        ResultRespone<Page<WxXbsqVo>> resultRespone = new ResultRespone<>();
        try {
            Page<WxXbsqVo> wxPage = wxXbsqService.getWxXbsqPage(page, dto);
            resultRespone.setCode(1);
            resultRespone.setResult(wxPage);
        } catch (RuntimeException e) {
            resultRespone.setCode(-1);
            resultRespone.setMessage(e.getMessage());
        }
        return resultRespone;
    }


    @GetMapping("/page")
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxXbsqPage(Page page, @ModelAttribute WxXbsq wxXbsq) {
        return ResultRespone.success(wxXbsqService.page(page, Wrappers.query(wxXbsq)));
    }


    @GetMapping("/{id}")
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id") String id) {
        return ResultRespone.success(wxXbsqService.getById(id));
    }

    @ApiOperation(value = "新增微信-校表申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxXbsq wxXbsq) {
        return ResultRespone.success(wxXbsqService.save(wxXbsq));
    }


    @ApiOperation(value = "修改微信-校表申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxXbsq wxXbsq) {
        return ResultRespone.success(wxXbsqService.updateById(wxXbsq));
    }

    @ApiOperation(value = "通过ID删除微信-校表申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}")
    public ResultRespone removeById(@PathVariable String id) {
        return ResultRespone.success(wxXbsqService.removeById(id));
    }

    @ApiOperation(value = "通过ID批量删除微信-校表申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds")
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxXbsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
